#!/usr/bin/perl

#workdir
$wdir = 'wdir/';

$out_f = 'tmp_output_';

#need to set for security reasons (we'll launch _only_ current dir executables)
$ENV{PATH} = ".";

$query = $ENV{'QUERY_STRING'};

sub PrettyPrint {
    print "<font color=\"#005500\">";
     while(<$f>) {
      # NL --> CR NL
      s/\12/\15\12/;
      s/\&/\&amp\;/g;
      s/ /\&nbsp\;/g;
      s/\</\&lt\;/g;
      s/\>/\&gt\;/g;
      s/\"/\&quot\;/g;
      print "$_<BR>"; 
    };
    print "</font>";
}

print 
    "Content-type: text/html\n\n" .
    "<HTML>\n<HEAD>\n<TITLE>REF</TITLE>\n".
    "<META NAME=\"PRAGMA\" CONTENT=\"no-cache\">".
    "</HEAD>\n" .
    "<BODY TEXT=\"#000000\" BGCOLOR=\"#FFFFFF\" LINK=\"#0000EE\" VLINK=\"#551A8B\" ALINK=\"#FF0000\">\n";

@forminputs = split (/&/, $query);
foreach $forminput (@forminputs) {
    ($name, $value) = split (/=/, $forminput);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack ("C", hex($1))/eg;
    $value =~ s/\r\n/\n/g;
    $form{$name} = $value;
}

#$ext = $form{'ext'};

@files = split (/,/, $form{'files'});
foreach $file (@files) {
    ($file, $ext) = split (/\./, $file);

    print
        "<b>" .
	"<font color=\"#005500\"> About to compile " .
        "</font>" .
	"<font color=\"#000077\">" .
        $file . 
        "." .
        $ext . 
        "</font>" .
        "</b>" .
        "<HR>\n" ;

    if (-e "$wdir$file.$ext") {

	print "<font color=\"#000077\"> Compiler Version: ";
	print "</font>";
	print "<font color=\"#005500\">";
	print `refc $wdir$file.$ext | brte.pl`;
	print "</font>";
	
	
	if ( -e "$wdir$file.lis") {
            # There exist errors.  
	    print "<H4>" .
		  "<font color=\"#000077\">Compilation Status: " .
		  "<font color=\"#aa0000\">" .
		  "Error(s) found... ". 
		  "</font>" .
		  "</font>" .
		  "</H4>\n" ;
	    print "<HR>\n"; 
	    
	    print "<b><TT>";
	    print "<font color=\"#005500\">";
	    
	    open(Listing, "< $wdir$file.lis");
	    $f = Listing;
	    while(<$f>) {
		s/\12/\15\12/;
		s/\&/\&amp\;/g;
		s/ /\&nbsp\;/g;
		s/\</\&lt\;/g;
		s/\>/\&gt\;/g;
		s/\"/\&quot\;/g;
                #Mark "Error" by red font color...
		s/^Error/\<font color\=\"\#aa0000\"\>Error\<\/font\>/g;
		print "$_<BR>"; 
	    };
	    close (Listing);
	    
	    print "</font>";
	    print "</TT></b>";
	    
	} else {
	    print "<h4><font color=\"#000077\">Compilation Status: ".
		  "<font color=\"#005500\">" .
		  "Success... ".
		  "</font>" .
		  "</font>" .
		  "</h4>";
	}
    }else{
	print "<font color=\"#aa0000\"> File $wdir$file.$ext doesn't exist.";
	print "</font>";
    }
    print  "<br><hr>";
    
}

print "<center> <font color=\"#000077\">";
print "<form>";
print "<INPUT type=button value=\"Close\" onClick=\'javascript: window.close ()\'>";
print "</form>";
print "</font> </center>";


print "</BODY>\n</HTML>\n";

sub CheckAndTouch () {
    $now = time;
    
    foreach $file (@files) {
	$f_name = sprintf ("%s%s%s", $wdir, $file, $ext);
	
	if (((@d) = stat($f_name)) && @d[4] == $< && @d[5] == $() {
	    if (!utime ($now, $now, $f_name)) {
		print "can't touch this file... $f_name\n";
	    }
	}
    }
}


CheckAndTouch ();


