#!/usr/bin/perl

#need to set for security reasons (we'll launch _only_ current dir executables)
$ENV{PATH} = ".";

#workdir
$wdir = 'wdir/';

$ext = '.ref';

$query = $ENV{'QUERY_STRING'};

sub Error2Html {
    print "Content-type: text/html\n\n" .
           "<HTML>\n<HEAD>\n<TITLE>Error</TITLE>\n<META NAME=\"PRAGMA\" CONTENT=\"no-cache\"></HEAD>\n" .
            "<BODY TEXT=\"#aa0000\" BGCOLOR=\"#ffffff\">\n" .
                "<center><b>@_[0]</b></center>";
    if (defined(@_[1])){
	print "@_[1]\n"
    }
    print "</BODY></HTML>";
    exit 1;
}

@forminputs = split (/&/, $query);
foreach $forminput (@forminputs) {
    ($name, $value) = split (/=/, $forminput);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack ("C", hex($1))/eg;
    $value =~ s/\r\n/\n/g;
    $form{$name} = $value;
}

$file = $form{'files'};

#check if the file exist
$f_name = sprintf ("%s%s%s", $wdir, $file, $ext);

if (!(-e $f_name)) {
    Error2Html ("file does not exists");
}

$index = $form{'index'};

$new_fname = sprintf ("tmp_ref_%d", $$);

print 
    "Content-type: text/html\n\n" .
    "<HTML>\n<HEAD>\n<TITLE>REF</TITLE>\n";

print "<script language=\"javascript\">\n" .
    "<!--\n" .
    "function applyChanges() {\n".
    "window.opener.document.ex_form.example.options[$index].value = \"$new_fname\";\n".
    "\n".
    "//window.close();\n".
    "}\n".
    "//-->\n".
    "</script>\n";

print"<META NAME=\"PRAGMA\" CONTENT=\"no-cache\"></HEAD>\n" .
    "<BODY TEXT=\"#000000\" BGCOLOR=\"#FFFFFF\" LINK=\"#0000EE\" VLINK=\"#551A8B\" ALINK=\"#FF0000\">\n";

print
	"<H3 ALIGN=CENTER>" . 
	"<font color=\"#000077\">" .
        $file . 
        "</font>" .
        "</H3>" .
        "<HR>\n" ;

print "<center> <b><TT>\n";
print "<font color=\"#005500\">\n";
print "<form method=\"post\" action=\"write_updated_file.cgi\">\n";
print "<TEXTAREA NAME=file ROWS=25 COLS=100 title=\"\">\n";

open (F, "< $wdir$file$ext") || print "Can't open $file$ext\n";
while (<F>){
    print $_;
}
close (F);

print "</TEXTAREA>\n";

print "<hr>";
print "<font color=\"#000077\">\n";
print "<INPUT type=hidden name=\"new_fname\" value=\"$new_fname$ext\">\n";
print "<INPUT type=submit value=\"Apply Changes\" onClick=\'javascript: applyChanges()\'>\n";
print "&nbsp;&nbsp;";
print "<INPUT type=button value=\"Close Window\" onClick=\'javascript: window.close ()\'>\n";
print "</font> \n";

print "</form>\n";
print "</font>\n";
print "</TT></b></center>\n";
print  "<hr>\n";

print "</BODY>\n</HTML>\n";

sub CheckAndTouch () {
    $now = time;
    
    if (((@d) = stat($f_name)) && @d[4] == $< && @d[5] == $() {
	if (!utime ($now, $now, $f_name)) {
	    print "can't touch this file... $f_name\n";
	}
    }
}

CheckAndTouch ();
