#!/usr/bin/perl 

#workdir
$wdir = 'wdir/';

#need to set for security reasons (we'll launch _only_ current dir executables)
$ENV{PATH} = ".";

$state = 0;

sub Error2Html {
    print "Content-type: text/html\n\n" .
           "<HTML>\n<HEAD>\n<TITLE>Error</TITLE>\n</HEAD>\n" .
            "<BODY TEXT=\"#aa0000\" BGCOLOR=\"#ffffff\">\n" .
                "<center><b>@_[0]</b></center>";
    if (defined(@_[1])){
	print "@_[1]\n"
    }
    print "</BODY></HTML>";
    exit 1;
}

if ($ENV{'REQUEST_METHOD'} eq 'POST') {
    $length = $ENV{'CONTENT_LENGTH'};
    $c_type = $ENV{'CONTENT_TYPE'};
    $nread = read STDIN, $ref_buffer, $length;


    ($garbage, $boundary) = split (/boundary=/, $c_type, 2);
}

$query = $ENV{'QUERY_STRING'};
if ($query ne '') {
    @forminputs = split (/&/, $query);
    foreach $forminput (@forminputs) {
	($name, $value) = split (/=/, $forminput);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack ("C", hex($1))/eg;
	$value =~ s/\r\n/\n/g;
	$form{$name} = $value;
    }
    $state = $form{'state'};
#    $ext = $form{'ext'};
    $index = $form{'index'};
}

if ($state != 1 && $state != 2) {
    Error2Html ("Wrong upload state");
}

if ($state == 1) {
print 
    "Content-type: text/html\n\n";
print 
'<HTML>' .
'<HEAD>' .
'<TITLE>Upload file</TITLE>' .
"<META NAME=\"PRAGMA\" CONTENT=\"no-cache\">".
'</HEAD>' .
'<BODY TEXT="#005500" BGCOLOR="#FFFFFF" LINK="#0000EE" VLINK="#551A8B" ALINK="#FF0000">' .
'<h3 align=center>' .
'<font color="#000077">Upload file</font>' .
'</h3>' .
'<HR>' .
'<center>' .
'<table>' .
'<tr><td>' .
'<FORM METHOD=POST  ENCTYPE="multipart/form-data" ';

print "ACTION=\"upload.cgi?state=2&index=$index\">";

print
'      Type a file\'s name to read the program from.<br> ' .
'  <INPUT type=file name="f_name" size="40">' .
'  <BR>' .
'  <INPUT type=submit value="Upload">' .
'     &nbsp;&nbsp;' .
'  <INPUT type=reset>' .
'     &nbsp;&nbsp;' .
'  <INPUT type=button value="Close Window" onClick=\'javascript: window.close ()\'><BR>'.
'</FORM>' .
'</td></tr>' .
'</table>' .
'</center>' .
'<HR>' .
'</BODY>' .
'</HTML>';
exit 0;  
}

($header, $rest) = split (/\r\n\r\n/, $ref_buffer, 2);
($program, $rest) = split (/\r\n--$boundary/, $rest, 2);

if ($program eq "") {
    Error2Html ("uploaded file name does not specified or empty file uploaded...\n");
}

$new_fname = sprintf ("%stmp_ref_%d.ref", $wdir, $$);
$file = sprintf ("tmp_ref_%d.ref", $$);

print 
    "Content-type: text/html\n\n" .
    "<HTML>\n<HEAD>\n<TITLE>REF</TITLE>\n".
    "<META NAME=\"PRAGMA\" CONTENT=\"no-cache\">";

print "<script language=\"javascript\">\n" .
    "<!--\n" .
    "function applyChanges() {\n".
    "window.opener.document.rf.ref_file.options[$index].value = \"$file\";\n".
    "\n".
    "}\n".
    "//-->\n".
    "</script>\n";

print"</HEAD>\n" .
    "<BODY TEXT=\"#000000\" BGCOLOR=\"#FFFFFF\" LINK=\"#0000EE\" VLINK=\"#551A8B\" ALINK=\"#FF0000\">\n";

print	"<H3 ALIGN=CENTER>" . 
    "<font color=\"#000077\">" .
    'Uploaded file:' .
    "</font>" .
    "</H3>";
print    "<HR>\n" ;

print "<center> <b><TT>\n";
print "<font color=\"#005500\">\n";

print "<form method=\"post\" action=\"write_updated_file.cgi\">\n";
print "<TEXTAREA NAME=file ROWS=25 COLS=100 title=\"\">";

print $program;

print "</TEXTAREA>\n";

print "<hr>";
print "<font color=\"#000077\">\n";
print "<INPUT type=hidden name=\"new_fname\" value=\"$new_fname\">\n";
print "<INPUT type=submit value=\"Apply Changes\" onClick=\'javascript: applyChanges()\'>\n";
print "&nbsp;&nbsp;";
print "<INPUT type=button value=\"Close Window\" onClick=\'javascript: window.close ()\'>\n";
print "</font> \n";

print "</form>\n";
print "</font>\n";
print "</TT></b></center>\n";
print  "<hr>\n";

print "</BODY>\n</HTML>\n";
