#!/usr/bin/perl

#workdir
$wdir = 'wdir/';

$ext = '.ref';

#need to set for security reasons (we'll launch _only_ current dir executables)
$ENV{PATH} = ".";

$query = $ENV{'QUERY_STRING'};

print 
    "Content-type: text/html\n\n" .
    "<HTML>\n<HEAD>\n<TITLE>REF</TITLE>\n".
    "<META NAME=\"PRAGMA\" CONTENT=\"no-cache\">".
    "</HEAD>\n" .
    "<BODY TEXT=\"#000000\" BGCOLOR=\"#FFFFFF\" LINK=\"#0000EE\" VLINK=\"#551A8B\" ALINK=\"#FF0000\">\n";

@forminputs = split (/&/, $query);
foreach $forminput (@forminputs) {
    ($name, $value) = split (/=/, $forminput);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack ("C", hex($1))/eg;
    $value =~ s/\r\n/\n/g;
    $form{$name} = $value;
}

@files = split (/,/, $form{'files'});
foreach $file (@files) {
    print
	"<H3 ALIGN=CENTER>" . 
	"<font color=\"#007700\"> File: </font>" .
	"<font color=\"#000077\"> " .
        $file . 
        $ext . 
        "</font>" .
        "</H3>" .
        "<HR>\n" ;

    print "<b><TT>";
    print "<font color=\"#005500\">";

    open (F, "< $wdir$file$ext") || print "Can't open $wdir$file$ext\n";
    while (<F>){
	s/\12/\15\12/;
	s/\&/\&amp\;/g;
	s/ /\&nbsp\;/g;
	s/\</\&lt\;/g;
	s/\>/\&gt\;/g;
	s/\"/\&quot\;/g;
	s/\[Yn\]/\[Yn\]\<BR\>/g;
	print "$_<BR>";
    }
    close (F);
    print "</font>";
    print "</TT></b>";
    print  "<br><hr>";

}

    print "<center> <font color=\"#000077\">";
    print "<form>";
    print "<INPUT type=button value=\"Close\" onClick=\'javascript: window.close ()\'>";
    print "</form>";
    print "</font> </center>";
    

print "</BODY>\n</HTML>\n";

sub CheckAndTouch () {
    $now = time;
    
    foreach $file (@files) {
	$f_name = sprintf ("%s%s%s", $wdir, $file, $ext);
	
	if (((@d) = stat($f_name)) && @d[4] == $< && @d[5] == $() {
	    if (!utime ($now, $now, $f_name)) {
		print "can't touch this file... $f_name\n";
	    }
	}
    }
}


CheckAndTouch ();


